@echo off & setlocal enableextensions enabledelayedexpansion

cls
echo   ###########################################################################
echo   #                     OUYA ROOT n BusyBox n USB Fix                       #
echo   #                   TheWiz(c)  Version 1.02   01.08.13                    #
echo   ###########################################################################
echo. 
echo  Deen0X MOD (LAN connection):
echo  Use this with an IP parameter to connect to your OUYA via RJ45 CABLE
echo with this, you avoid to install USB drivers on your computer.
echo example of use:
echo ouys_root_mod.cmd 192.168.1.50

if %1_! == _! goto normalrun
echo ***** Connect to OUYA device
adb connect %1:5555
adb devices
echo ***** If you see yor android device (OUYA) connected (did you see the IP?),
echo ***** then you are ok to continue. Any other case, stop this script using
echo ***** [CTRL] + [C]
pause

:normalrun
if not exist "%USERPROFILE%\.android\" SET MKDIR=1
IF !MKDIR!==1 (
	echo *** Copy Android USB Config
	cd /d %USERPROFILE% 
	mkdir .android
	cd /d %~dp0
	xcopy /E .\adb_usb "%USERPROFILE%\.android\" >nul
)

adb kill-server
echo *** Run ADB
echo 0x2836 >> "%USERPROFILE%\.android\adb_usb.ini"
FOR /F "tokens=1" %%A IN ('adb devices')  DO (
	set TXTTMP=%%A
	set LIST=!TXTTMP:~0,4!
	if !FLAG!==1 (
		set DEVICE=!TXTTMP:~0,16!
		if !DEVICE!==%%A (
			echo *** Device Found !DEVICE!
			set DEVICE_FLAG=1
		) ELSE (
			echo *** No Device Found!
			goto :exit
		)
	)

	if !LIST!==List (
		set FLAG=1
	)
)

if !DEVICE_FLAG!==1 (
	FOR /F "tokens=1" %%A IN ('adb shell su -c "ls sdcard/su"') DO (
		set TXTTMP=%%A
		set ROOT=!TXTTMP:~-1!
		if !ROOT!==: (
			echo *** ROOT Device
			cd /d %~dp0
			adb shell su -c "mount -o rw,remount -t ext4 /dev/block/platform/sdhci-tegra.3/by-name/APP"
			adb push su /sdcard/su
			adb shell su -c "cat /sdcard/su > /system/xbin/su"
			adb shell su -c "ln -s /system/xbin/su /system/bin/su"
			adb shell su -c "chmod 6755 /system/xbin/su"
		) ELSE (
			echo *** Device is already ROOT!
		)
	)

	echo *** Install All packs in folder
	for /F %%i in ('dir /b /o:n packs\*') do (
		echo *** *** Installing %%i
		adb install -r packs\%%i
	)

	echo *** FIX USB Bug
	adb shell su -c "mount -o remount,rw /system"
	adb shell su -c "chmod 777 /system/etc/vold.fstab"
	adb push fix_usb/vold.fstab /system/etc/

	echo *** Reboot Device
	adb reboot
) ELSE (
	goto :exit
)

:exit
echo *** Exit ***
adb kill-server
endlocal